#ifndef _ADATA_API_ADMXRC2_PLATFORM_H
#define _ADATA_API_ADMXRC2_PLATFORM_H

/*
** File: admxrc2_platform.h  
** Project: ADMXRC2 API module library
** Purpose: Interface to VxWorks-specific functions for ADMXRC2 API module library
**
** (C) Copyright Alpha Data 2016
*/

#include <vxWorks.h>
#include <semLib.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include <portability.h>

#include <admxrc2/platform.h>
#include <admxrc2/status.h>
#include <admxrc2/types.h>

#define ADMXRC2_HAS_USER_EVENT_HANDLE PORTABLE_HAS_USER_EVENT_HANDLE
typedef portable_user_event_handle_t admxrc2_user_event_handle_t;

extern ADMXRC2_STATUS
admxrc2OpenDevice(
  unsigned int index,
  int bUnprivileged,
  ADMXRC2_HANDLE* phDevice);

extern ADMXRC2_STATUS
admxrc2CloseDevice(
  ADMXRC2_HANDLE hDevice);

#define admxrc2Ioctl(hDevice, code, pIoctl, hEvent, sizeIn, sizeOut) _admxrc2Ioctl(hDevice, code, pIoctl, sizeIn, sizeOut)

extern ADMXRC2_STATUS
_admxrc2Ioctl(
  ADMXRC2_HANDLE hDevice,
  unsigned int code,
  void* pIoctl,
  unsigned int sizeIn,
  unsigned int sizeOut);
  
extern ADMXRC2_STATUS
admxrc2MapRegion(
  ADMXRC2_HANDLE hCard,
  unsigned int regionTag,
  uint64_t offset,
  uint64_t length,
  void** ppVirtualBase);

extern ADMXRC2_STATUS
admxrc2UnmapRegion(
  ADMXRC2_HANDLE hCard,
  void* pVirtualBase);

extern ADMXRC2_STATUS
admxrc2FindRegion(
  ADMXRC2_HANDLE hAdmxrc2,
  unsigned int regionTag,
  unsigned int ordinal,
  void** ppVirtualBase,
  uint64_t* pOffset,
  uint64_t* pLength);

extern void
admxrc2MmapInitialize(
  void);

#if (_WRS_VXWORKS_MAJOR >= 6)
# define portableFormatStringA1(buf, max, format, arg1) snprintf(buf, max, format, arg1)
# define portableFormatStringA2(buf, max, format, arg1, arg2) snprintf(buf, max, format, arg1, arg2)
# define portableFormatStringA3(buf, max, format, arg1, arg2, arg3) snprintf(buf, max, format, arg1, arg2, arg3)
# define portableFormatStringA4(buf, max, format, arg1, arg2, arg3, arg4) snprintf(buf, max, format, arg1, arg2, arg3, arg4)
#else
  /* Need VxWorks 6.x for snprintf() */
# define portableFormatStringA1(buf, max, format, arg1) sprintf(buf, format, arg1)
# define portableFormatStringA2(buf, max, format, arg1, arg2) sprintf(buf, format, arg1, arg2)
# define portableFormatStringA3(buf, max, format, arg1, arg2, arg3) sprintf(buf, format, arg1, arg2, arg3)
# define portableFormatStringA4(buf, max, format, arg1, arg2, arg3, arg4) sprintf(buf, format, arg1, arg2, arg3, arg4)
#endif

#endif
