/*
** File: vxw_param.c  
** Project: VxWorks ADM-XRC monolithic driver
** Purpose: Driver parameters
**
** (C) Copyright Alpha Data 2016
*/

#include "df.h"
#include "dfvxworks.h"

/*
** Driver parameters are simply symbols that are exported to the namespace of
** the VxWorks kernel.
*/

unsigned int admxrcDrvDmaMapLength = 64;
unsigned int admxrcDrvEnableVpdWrite = 0;
unsigned int admxrcDrvPciAddress64Bit = 0;
unsigned int admxrcDrvPrimaryCommonBufferCount = 0;
unsigned int admxrcDrvPrimaryCommonBufferAlignment = 32U;
unsigned int admxrcDrvPrimaryCommonBufferSizeLow = 0x10000U;
unsigned int admxrcDrvPrimaryCommonBufferSizeHigh = 0;
unsigned int admxrcDrvPolledInterrupts = 0;

DfVxwDriverParameterUint32 g_dfVxwDriverParamUint32[] = {
  { "DmaMapLength", &admxrcDrvDmaMapLength },
  { "PrimaryCommonBufferCount", &admxrcDrvPrimaryCommonBufferCount },
  { "PrimaryCommonBufferAlignment", &admxrcDrvPrimaryCommonBufferAlignment },
  { "PrimaryCommonBufferSizeLow", &admxrcDrvPrimaryCommonBufferSizeLow },
  { "PrimaryCommonBufferSizeHigh", &admxrcDrvPrimaryCommonBufferSizeHigh },
  { NULL, NULL } /* Terminator */
};

DfVxwDriverParameterBoolean g_dfVxwDriverParamBoolean[] = {
  { "EnableVpdWrite", &admxrcDrvEnableVpdWrite },
  { "PciAddress64Bit", &admxrcDrvPciAddress64Bit },
  { "PolledInterrupts", &admxrcDrvPolledInterrupts },
  { NULL, NULL } /* Terminator */
};

DfVxwDriverParameterString g_dfVxwDriverParamString[] = {
  { NULL, NULL, 0 } /* Terminator */
};
